package com.sun.faces.ext.component;

import javax.faces.component.UIComponentBase;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import java.io.IOException;
import javax.faces.context.ResponseWriter;

public class UIFocus extends UIComponentBase {

    @Override
    public void encodeEnd(FacesContext context) throws IOException {
        String forID = (String) getAttributes().get("for");
        ResponseWriter writer = context.getResponseWriter();
        UIComponent parentComponent = getParent();
        String parentID = parentComponent.getClientId(context);
        String targetID = parentID+":"+forID;
        writer.startElement("script", this);
        writer.writeText("setFocus('",null);
        writer.writeText(targetID, null);
        writer.writeText("');\n",null);
        writer.writeText("function setFocus(elementId) { var element = " +
                "document.getElementById(elementId); if (element && element.focus) " +
                "{ element.focus(); } }",null);
        writer.endElement("script");        
    }
            
    @Override
    public String getFamily() {
        return "FocusFamily";
    }
}  